#include <Wire.h>           //Einbinden der Bibliothek zur Messung der Helligkeit
int BH1750_address1 = 0x23; //i2c Addresse des ersten Helligkeitssensors
int BH1750_address2 = 0x5C; //i2c Addresse des zweiten Helligkeitssensors
byte buff[2];               //Array zum Speichern der empfangenenen Helligkeitswerte
int bound =100;             //Grenzwert für ein schwarzes Feld
int numBlackFields=0;       //Gezählte Zahl an schwarzen Feldern
int finger1=4;              //Pins der Finger
int finger2=2;
double time1=0;             //Zeit zu der zuletzt ein schwarzes Feld entdeckt wurde
double time2=0;             //Zeit für den zweiten Sensor


void setup(){
   Wire.begin();            //Starten der Kommunikation mit Helligkeitssensoren
   BH1750_Init(BH1750_address1);
   BH1750_Init(BH1750_address2);
   pinMode(finger1,OUTPUT);       //Pins der Finger.
   pinMode(finger2,OUTPUT);
   Serial.begin(9600);            //Starten des seriellen Monitors
   }

void loop(){
   float value=0;                 //Variable der gemessenen Helligkeit
   if(BH1750_Read(BH1750_address1)==2)          //Wenn ein Wert verfügbar ist
       {value=((buff[0]<<8)|buff[1])/1.2;}      //Lese das Array aus und bestimme daraus den Helligkeitswert
   if(value<bound&&millis()-time1>200-0.015*numBlackFields)  //Wenn die Grenze unterschritten ist und das letzte schwarze Feld lange her ist 
       { 
       numBlackFields++;                        //Zähle ein neues schwarzes Feld    
       delayMicroseconds(75000-30*numBlackFields);   //Warte eine bestimmte Zeit bevor der Finger betätigt wird. 
       pushFinger(finger1);                     //Betätige den Finger
       time1=millis();                          //Setzte die Zeit zu der ein schwarzes Feld gesehen wurde auf jetzt
       }
    value=0;                      //Helligkeitswert zurücksetzen
    if(BH1750_Read(BH1750_address2)==2)
       {value=((buff[0]<<8)|buff[1])/1.2;}
    if(value<bound&&millis()-time2>200-0.015*numBlackFields)
       {
       numBlackFields++;
       delayMicroseconds(75000-30*numBlackFields);
       pushFinger(finger2);
       time2=millis();
       }
}

void pushFinger(int finger)
{
    digitalWrite(finger,HIGH);      //Betätige den Finger
    delay(80);                      //Warte kurz  
    digitalWrite(finger,LOW);       //Löse den Finger
}


void BH1750_Init(int address){    //Von der Bibliothek vorgegebene Methoden zur Initialisierung und Auslesung der Helligkeitssensoren
  Wire.beginTransmission(address);
  Wire.write(0x10);
  Wire.endTransmission();
}

byte BH1750_Read(int address){
  
  byte i=0;
  Wire.beginTransmission(address);
  Wire.requestFrom(address, 2);
  while(Wire.available()){
    buff[i] = Wire.read(); 
    i++;
  }
  Wire.endTransmission();  
  return i;
}
